#pragma once

//game client listener
namespace a8
{
    class TcpListener;
}

class GSListener : public a8::Singleton<GSListener>
{
 private:
    GSListener() {};
    friend class a8::Singleton<GSListener>;

 public:
    enum { HID = HID_GSListener };

 public:
    void Init();
    void UnInit();

    template <typename T>
    void SendMsg(unsigned short socket_handle, T& msg)
    {
        static int msgid = ::Net_GetMessageId(msg);
        Net_SendMsg(tcp_listener_, socket_handle, 0, msgid, msg);
    }

    void ForwardTargetConnMsg(MsgHdr& hdr);
    void SendText(unsigned short sockhandle, const std::string& text);

    void ForceCloseClient(unsigned short sockhandle);
    void MarkClient(unsigned short sockhandle, bool is_active);

 private:
    a8::TcpListener *tcp_listener_ = nullptr;
};
