#include "precompile.h"

#include <a8/mutable_xobject.h>

#include "handlermgr.h"

#include "GSListener.h"

void _GMAppEcho(a8::HTTPRequest& request, a8::MutableXObject* xobj)
{
    xobj->SetVal("error_code", 1);
    xobj->SetVal("error_msg", "");
    xobj->SetVal("error_msg", a8::Get(request, "msg"));
}

void HandlerMgr::Init()
{
    RegisterNetMsgHandlers();
    RegisterGMMsgHandler("app$echo", _GMAppEcho);
}

void HandlerMgr::UnInit()
{
}

void HandlerMgr::RegisterNetMsgHandlers()
{
}

void HandlerMgr::ProcGMMsg(int sockhandle, const std::string& url, const std::string& querystr)
{
    if (url != "/index.php") {
        GSListener::Instance()->SendText(sockhandle, a8::HttpResponse(404, ""));
        return;
    }

    a8::HTTPRequest request;
    a8::ParserUrlQueryString(querystr.c_str(), request);

    std::string msgname = a8::Get(request, "c").GetString() + "$" + a8::Get(request, "a").GetString();
    auto itr = gmhandlers_.find(msgname);
    if (itr != gmhandlers_.end()) {
        a8::MutableXObject* xobj = a8::MutableXObject::NewObject();
        itr->second(request, xobj);

        std::string response;
        xobj->ToJsonStr(response);
        GSListener::Instance()->SendText(sockhandle, a8::HttpResponse(response));

        delete xobj;
    } else {
        GSListener::Instance()->SendText(sockhandle, a8::HttpResponse("{}"));
    }
}

void HandlerMgr::RegisterGMMsgHandler(const std::string& msgname,
                                      void (*handler)(a8::HTTPRequest&, a8::MutableXObject*))
{
    gmhandlers_[msgname] = handler;
}
