#pragma once

#include <a8/basehttpsession.h>

#include "framework/cpp/netmsghandler.h"

namespace a8
{
    class MutableXObject;
}

class HandlerMgr : public a8::Singleton<HandlerMgr>
{

 private:
    HandlerMgr() {};
    friend class a8::Singleton<HandlerMgr>;

 public:

    void Init();
    void UnInit();

    NetMsgHandlerObject gcmsghandler;
    NetMsgHandlerObject rsmsghandler;
    NetMsgHandlerObject gsmsghandler;

    void ProcGMMsg(int sockhandle, const std::string& url, const std::string& quyerstr);

 private:
    void RegisterNetMsgHandlers();
    void RegisterGMMsgHandler(const std::string& msgname,
                              void (*)(a8::HTTPRequest&, a8::MutableXObject*));

    std::map<std::string, void (*)(a8::HTTPRequest&, a8::MutableXObject*)> gmhandlers_;
};
