#include "precompile.h"

#include "jsondatamgr.h"
#include "app.h"

void JsonDataMgr::Init()
{
    std::string wsproxyserver_cluster_json_file;
    std::string targetserver_cluster_json_file;
    if (getenv("is_dev_env")) {
        wsproxyserver_cluster_json_file = "/var/data/conf_test/game1008/wsproxy/game1008.wsproxy.cluster.json";
        targetserver_cluster_json_file = "/var/data/conf_test/game1008/wsproxy/game1008.gameserver.cluster.json";
    } else {
        wsproxyserver_cluster_json_file = "../config/game1008.wsproxy.cluster.json";
        targetserver_cluster_json_file = "../config/game1008.gameserver.cluster.json";
    }
    wsproxyserver_cluster_json_.ReadFromFile(wsproxyserver_cluster_json_file);
    targetserver_cluster_json_.ReadFromFile(targetserver_cluster_json_file);
}

void JsonDataMgr::UnInit()
{
}

std::shared_ptr<a8::XObject> JsonDataMgr::GetConf()
{
    if (App::Instance()->instance_id < 1 || App::Instance()->instance_id > wsproxyserver_cluster_json_.Size()) {
        abort();
    }
    return wsproxyserver_cluster_json_[App::Instance()->instance_id - 1];
}

std::shared_ptr<a8::XObject> JsonDataMgr::GetTargetServerClusterConf()
{
    return std::make_shared<a8::XObject>(targetserver_cluster_json_);
}
